/* Comp 116 Fall 2018, programming assignment 3
 * Copyright (c) 2018
 * Wheaton College, Computer Science Department, Norton MA
 * M. Gagne
 */

/* Name: */

#include <iostream>
#include <string>
#include "ppmio.h"
#include "filters.h"

using namespace std;

int main() {
    string infile, outfile, filter;

    // User interface
    cout << "Enter the name of the input .ppm file: ";
    cin >> infile;
    cout << "Enter the name of the output .ppm file: ";
    cin >> outfile;

    // Get the array from the input file
    int width, height;
    int* ppmArray = readFile(infile, width, height);

    // TODO: test the return value to make sure the file was valid

    // Repeat until a valid filter is entered
    bool done = false;
    do {
        cout << "Enter the filter to be applied: " << flush;
        cin >> filter;

        if (filter == "removeRed") {
            removeRed(ppmArray, width, height);
            done = true;
            // the previous line ensures we get out of the loop
        }

        // TODO: add other transformations
        // TODO: print error message if the filter was invalid

    } while (!done);

    writeFile(outfile,ppmArray,width,height);

    // free dynamically allocated array
    delete[] ppmArray;

    return 0;
}