#ifndef PRGASST3_PPMIO_H
#define PRGASST3_PPMIO_H
/* Comp 116 Fall 2018, programming assignment 3
 * Copyright (c) 2018
 * Wheaton College, Computer Science Department, Norton MA
 * M. Gagne
 */

/* Name: */

#include <string>
using std::string;


/* readFile: reads a ppm file and returns an array containing the information about
 *           the pixels
 *   params: infile - a string containing the name of the file to read
 *           width - a ref to an int, to be filled with width of the picture
 *           height - ref to an int, to be filled with the height of the picture
 *   returns: a pointer to a dynamically allocated array of the pixels
 *            the function should return nullptr if the file is invalid or if an error
 *            happens while reading the file
 */
int* readFile(string infile, int& width, int& height);

/* writeFile: takes
 *   params: outfile - the file to which the info should be written
 *           ppmArray - a pointer to the beginning of an array of the pixels
 *           width - an int, the width of the picture
 *           height - an int, the height of the picture
 *   does not return anything (but file has been written to)
 */
void writeFile(string outfile, int* ppmArray, int width, int height);

#endif //PRGASST3_PPMIO_H
